var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import { createElement as h } from 'react';
import { combineRules } from 'fela';
import PropTypes from 'prop-types';
import context from './context';

var styled = function styled(BaseComponent) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var Component = function Component(_ref, ctx) {
      var is = _ref.is,
          props = _objectWithoutProperties(_ref, ['is']);

      var _ctx$context$ns = ctx[context.ns],
          renderer = _ctx$context$ns.renderer,
          theme = _ctx$context$ns.theme;

      var stylePropKeys = Object.keys(Component.propTypes || {});
      var styleProps = Object.assign({ theme: theme }, props);

      var rules = args.map(function (a) {
        return typeof a !== 'function' ? function () {
          return a;
        } : a;
      }).filter(function (s) {
        return s !== null;
      });

      var className = renderer.renderRule(combineRules.apply(undefined, _toConsumableArray(rules)), styleProps);

      return h(is || BaseComponent, _extends({
        className: className
      }, Object.keys(props).filter(function (key) {
        return typeof BaseComponent == 'function' ? !stylePropKeys.includes(key) : true;
      }).reduce(function (obj, key) {
        return _extends({}, obj, _defineProperty({}, key, props[key]));
      }, {})));
    };

    Component.contextTypes = context.types;

    return Component;
  };
};

export default styled;